image: docker:19.03.8

variables:
  DOCKER_TLS_CERTDIR: "/certs"  
  CONTAINER_TEST_IMAGE: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG:$CI_COMMIT_SHA
  CONTAINER_RELEASE_IMAGE_1: $CI_REGISTRY_IMAGE:latest   
  CONTAINER_RELEASE_IMAGE_2: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  CONTAINER_RELEASE_IMAGE_3: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
  SAST_DEFAULT_ANALYZERS: "eslint"


services:
  - docker:19.03.8-dind

include:
  # Disabling Qaulity because of the issue with   
  # - template: Code-Quality.gitlab-ci.yml  
  - template: SAST.gitlab-ci.yml  
  - template: Dependency-Scanning.gitlab-ci.yml
  - template: Container-Scanning.gitlab-ci.yml
  - template: License-Scanning.gitlab-ci.yml

stages:
  - build
  - test  
  - release

# Disabling Qaulity because of the issue with   
# code_quality:
#   stage: test
#   artifacts:
#     paths: [gl-code-quality-report.json]  

container_scanning:
  variables:    
    GIT_STRATEGY: fetch    

build:
  stage: build
  script:
    - docker login -u $CI_DEPLOY_USER -p $CI_DEPLOY_PASSWORD $CI_REGISTRY    
    - docker build --pull --build-arg NODE_VERSION=$NODE_BASE_IMAGE  -t $CONTAINER_TEST_IMAGE .
    - docker push $CONTAINER_TEST_IMAGE    

test:
  stage: test
  script:    
    - docker login -u $CI_DEPLOY_USER -p $CI_DEPLOY_PASSWORD $CI_REGISTRY
    - docker pull $CONTAINER_TEST_IMAGE
    - docker run --name $CI_PROJECT_NAME -d $CONTAINER_TEST_IMAGE

release_image:
   stage: release
   script:
     - docker login -u $CI_DEPLOY_USER -p $CI_DEPLOY_PASSWORD $CI_REGISTRY
     - docker pull $CONTAINER_TEST_IMAGE
     - docker tag $CONTAINER_TEST_IMAGE $CONTAINER_RELEASE_IMAGE_1
     - docker tag $CONTAINER_TEST_IMAGE $CONTAINER_RELEASE_IMAGE_2
     - docker tag $CONTAINER_TEST_IMAGE $CONTAINER_RELEASE_IMAGE_3
     - docker push $CONTAINER_RELEASE_IMAGE_1
     - docker push $CONTAINER_RELEASE_IMAGE_2
     - docker push $CONTAINER_RELEASE_IMAGE_3
   only:
     - master     
     - /^.*-release$/